<?php 
/*
	* pm_content_auditor_adminscripts
	* Enq Scripts and StyleSheets
	* FontAwesome: //maxcdn.bootstrapcdn.com/font-awesome/4.3.0/css/font-awesome.min.css

*/

function pm_content_auditor_register_settings() {
	add_menu_page(esc_html(sprintf(__( '%s ', 'pm-process-mover' ), PM_CONTENT_AUDITOR_PLUGIN_NAME)), esc_html(sprintf(__( '%s ', 'pm-process-mover' ), PM_CONTENT_AUDITOR_PLUGIN_NAME)), 'manage_options', 'pm_content_auditor_export', 'pm_content_auditor_export_page', '' );
	add_submenu_page( 'pm_content_auditor_export', esc_html(__( 'Settings', 'pm-process-mover' )), esc_html(__( 'Settings', 'pm-process-mover' )), 'manage_options', 'pm_content_auditor_settings', 'pm_content_auditor_settings_page');
	add_submenu_page( 'pm_content_auditor_export', esc_html(__( 'Logs', 'pm-process-mover' )), esc_html(__( 'Logs', 'pm-process-mover' )), 'manage_options', 'pm_content_auditor_logs', 'pm_content_auditor_logs_page');
	add_action( 'admin_init', 'pm_content_auditor_settings_register_callback' );
	
}
add_action( 'admin_menu', 'pm_content_auditor_register_settings' );


/*
	* pm_content_auditor_settings_register_callback
*/

function pm_content_auditor_settings_register_callback() {
	//register our settings
	register_setting( 'pm-content-auditor-settings-group', PM_CONTENT_AUDITOR_SETTINGS_OPTION, 'pm_content_auditor_settings_validate');
}

/*
	* pm_content_auditor_settings_validate
*/

function pm_content_auditor_settings_validate($input) {
	$array = array();
	foreach($input as $key => $values) {
		if(is_array($input[$key])) {
			//$input[$key] = array_filter($input[$key]);
			if($input[$key]) {
				//$values = array_filter($values);
				if(is_array($values)){
					foreach($values as $vkey => $value) {
						$array[$key][$vkey] = wp_strip_all_tags($value,true);
					}
				}
			}
			
		}
	}
	return $array;
}


/*
	* Export Page
*/


function pm_content_auditor_export_page() {
	wp_enqueue_style('jquery-ui-style', 'https://cdnjs.cloudflare.com/ajax/libs/jqueryui/1.12.0/jquery-ui.min.css', '', PM_CONTENT_AUDITOR_VERSION, 'all' );
	
	wp_enqueue_style( 'pm-font-awesome', 'https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.6.3/css/font-awesome.min.css', '', PM_CONTENT_AUDITOR_VERSION, 'all' );
	wp_enqueue_style( 'pm-bootstrap', 'https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css', '', PM_CONTENT_AUDITOR_VERSION, 'all' );	
	wp_enqueue_style( 'pm-content-auditor-style', PM_CONTENT_AUDITOR_DIR.'modules/src/css/pm-content-auditor.css', '', PM_CONTENT_AUDITOR_VERSION, 'all' );
	wp_enqueue_script( 'jquery-ui-datepicker' );
	wp_enqueue_script( 'pm-bootstrap-script', 'https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js', array('jquery'), PM_CONTENT_AUDITOR_VERSION, true );
	
	wp_enqueue_script( 'pm-content-auditor-admin-script', PM_CONTENT_AUDITOR_DIR.'modules/src/js/pm-content-auditor.js', array('jquery'), PM_CONTENT_AUDITOR_VERSION, true );
	$myAjax = array( 'ajaxurl' => admin_url( 'admin-ajax.php' ), 'formData' => array(), 'time' => time() );
	wp_localize_script( 'pm-content-auditor-admin-script', 'pmCa', $myAjax);	
	$options = get_option(PM_CONTENT_AUDITOR_SETTINGS_OPTION, array());
	?>
	<div id="content_auditor_export" class="wrap">
		
		<form class="form-horizontal" name="pm-content-auditor-export-form" id="pm-content-auditor-export-form" method="POST" role="form" data-toggle="validator">
			<fieldset>
			<!-- Form Name -->
			<legend><?php esc_html(_e( 'Export Settings', 'pm-process-mover')); ?></legend>
			<!-- Select Basic -->
			<div class="form-group">
				<label class="col-md-1 control-label" for="selectbasic"><?php esc_html(_e( 'Post Type', 'pm-process-mover')); ?></label>
				<div class="col-md-4">
					<?php print pm_content_auditor_post_types_html(); ?>
				</div>
			</div>
			<!-- Multiple Radios -->
			<div id="post_range_wrapper" class="form-group">
			  <label class="col-md-1 control-label" for="Range"><?php esc_html(_e( 'Post Range', 'pm-process-mover')); ?></label>
			  <div class="col-md-4">
			  <div class="radio">
			    <label for="Range-0">
			      <input type="radio" class="post_range" name="post_range" id="Range-0" value="all" checked="checked">
			      <?php esc_html(_e( 'All Content', 'pm-process-mover')); ?>
			    </label>
				</div>
			  <div class="radio">
			    <label for="Range-1">
			      <input type="radio" class="post_range" name="post_range" id="Range-1" value="date_range">
			      <?php esc_html(_e( 'Date Range', 'pm-process-mover')); ?>
			    </label>
				</div>
			  </div>
			</div>
			<section id="date_range_wrapper">
			<div class="form-group ">
				<label class="col-md-1 control-label" for="start_date"><?php esc_html(_e( 'After Date', 'pm-process-mover')); ?></label>
				<div class="col-md-4">
					<input class="form-control" id="start_date" name="start_date" placeholder="MM/DD/YYYY" type="text" />
				</div>
		    </div>
			
			<div class="form-group ">
				<label class="col-md-1 control-label" for="end_date"><?php esc_html(_e( 'Before Date', 'pm-process-mover')); ?></label>
				<div class="col-md-4">
					<input class="form-control" id="end_date" name="end_date" placeholder="MM/DD/YYYY" type="text" />
				</div>
		    </div>
			</section>
			<!-- Multiple Checkboxes -->
			<div class="form-group">
				<label class="col-md-1 control-label" for="post_status"><?php esc_html(_e( 'Post Status', 'pm-process-mover')); ?></label>
				<div class="col-md-4">
					<div class="checkbox">
						<label for="post_status-0">
						<input checked="checked" type="checkbox" name="post_status" id="post_status-0" value="publish">
						<?php esc_html(_e( 'Published', 'pm-process-mover')); ?>
						</label>
					</div>
					<div class="checkbox">
						<label for="post_status-1">
						<input type="checkbox" name="post_status" id="post_status-1" value="draft">
						<?php esc_html(_e( 'Draft', 'pm-process-mover')); ?>
						</label>
					</div>
					
					<div class="checkbox">
						<label for="post_status-2">
						<input type="checkbox" name="post_status" id="post_status-2" value="pending">
						<?php esc_html(_e( 'Pending', 'pm-process-mover')); ?>
						</label>
					</div>
					
					<div class="checkbox">
						<label for="post_status-3">
						<input type="checkbox" name="post_status" id="post_status-3" value="private">
						<?php esc_html(_e( 'Private', 'pm-process-mover')); ?>
						</label>
					</div>
					
					<div class="checkbox">
						<label for="post_status-4">
						<input type="checkbox" name="post_status" id="post_status-4" value="future">
						<?php esc_html(_e( 'Future', 'pm-process-mover')); ?>
						</label>
					</div>
				</div>
			</div>			
			</fieldset>
			
			<fieldset>
			<!-- Form Name -->
			<legend><?php esc_html(_e( 'Primary Fields', 'pm-process-mover')); ?></legend>

			<!-- Multiple Checkboxes -->
			<div class="form-group">
			  <label class="col-md-1 control-label" for="primary_fields"><?php esc_html(_e( 'Include following', 'pm-process-mover')); ?></label>
			  <div class="col-md-4">
			  <div class="checkbox">
			    <label for="primary_fields-0">
			      <input checked="checked" type="checkbox" name="primary_fields" id="primary_fields-0" value="title">
				  <?php esc_html(_e( 'Title', 'pm-process-mover')); ?>
			    </label>
				</div>
			  <div class="checkbox">
			    <label for="primary_fields-1">
			      <input checked="checked" type="checkbox" name="primary_fields" id="primary_fields-1" value="published_date">
			      <?php esc_html(_e( 'Date published', 'pm-process-mover')); ?>
			    </label>
				</div>
			  <div class="checkbox">
			    <label for="primary_fields-2">
			      <input checked="checked" type="checkbox" name="primary_fields" id="primary_fields-2" value="post_status">
			      <?php esc_html(_e( 'Post Status', 'pm-process-mover')); ?>
			    </label>
				</div>
			  <div class="checkbox">
			    <label for="primary_fields-3">
			      <input checked="checked" type="checkbox" name="primary_fields" id="primary_fields-3" value="post_author">
			      <?php esc_html(_e( 'Author', 'pm-process-mover')); ?>
			    </label>
				</div>
			  <div class="checkbox">
			    <label for="primary_fields-4">
			      <input type="checkbox" name="primary_fields" id="primary_fields-4" value="category">
			      <?php esc_html(_e( 'Category', 'pm-process-mover')); ?>
			    </label>
				</div>
			  <div class="checkbox">
			    <label for="primary_fields-5">
			      <input type="checkbox" name="primary_fields" id="primary_fields-5" value="tags">
			      <?php esc_html(_e( 'Tags', 'pm-process-mover')); ?>
			    </label>
				</div>
			  <div class="checkbox">
			    <label for="primary_fields-6">
			      <input checked="checked" type="checkbox" name="primary_fields" id="primary_fields-6" value="featured_image">
			      <?php esc_html(_e( 'Featured Image (ID)', 'pm-process-mover')); ?>
			    </label>
				</div>
			  </div>
			</div>
			</fieldset>
			
			<fieldset>
			<!-- Form Name -->
			<legend><?php esc_html(_e( 'Social Fields', 'pm-process-mover')); ?></legend>

			<!-- Multiple Checkboxes -->
			<div class="form-group">
			  <label class="col-md-1 control-label" for="social_fields"><?php esc_html(_e( 'Select Social Fields', 'pm-process-mover')); ?></label>
			  <div class="col-md-4">
				<div class="checkbox">
			    <label for="social_fields-0">
			      <input type="checkbox" name="social_fields" id="social_fields-0" value="facebook_shares">
			      <?php esc_html(_e( 'Facebook Shares', 'pm-process-mover')); ?>
			    </label>
				</div>
				<div class="checkbox">
			    <label for="social_fields-1">
			      <input type="checkbox" name="social_fields" id="social_fields-1" value="googleplus">
			      <?php esc_html(_e( 'Google +1s', 'pm-process-mover')); ?>
			    </label>
				</div>
			  </div>
			</div>
			</fieldset>
			
			<!-- Multiple Checkboxes -->
			<fieldset>
				<!-- Form Name -->
				<legend><?php esc_html(_e( 'Yoast SEO Fields', 'pm-process-mover')); ?></legend>
				<div class="form-group">
					<label class="col-md-1 control-label" for="yoast_seo"><?php esc_html(_e( 'Available Fields', 'pm-process-mover')); ?></label>
					<div class="col-md-4">
						<div class="checkbox">
							<label for="yoast_seo-0">
								<input type="checkbox" name="yoast_seo" id="yoast_seo-0" value="_yoast_wpseo_focuskw">
								<?php esc_html(_e( 'Focus Keyword', 'pm-process-mover')); ?>
							</label>
						</div>
						
						<div class="checkbox">
							<label for="yoast_seo-1">
								<input type="checkbox" name="yoast_seo" id="yoast_seo-1" value="_yoast_wpseo_title">
								<?php esc_html(_e( 'SEO Title', 'pm-process-mover')); ?>
							</label>
						</div>
						
						<div class="checkbox">
							<label for="yoast_seo-2">
								<input type="checkbox" name="yoast_seo" id="yoast_seo-2" value="_yoast_wpseo_metadesc">
								<?php esc_html(_e( 'Meta Desc', 'pm-process-mover')); ?>
							</label>
						</div>
						
						<div class="checkbox">
							<label for="yoast_seo-3">
								<input type="checkbox" name="yoast_seo" id="yoast_seo-3" value="_yoast_wpseo_linkdex">
								<?php esc_html(_e( 'Link Dex', 'pm-process-mover')); ?>
							</label>
						</div>
						
						<div class="checkbox">
							<label for="yoast_seo-4">
								<input type="checkbox" name="yoast_seo" id="yoast_seo-4" value="_yoast_wpseo_content_score">
								<?php esc_html(_e( 'Content Score', 'pm-process-mover')); ?>
							</label>
						</div>
					</div>
				</div>
			</fieldset>
			
			<fieldset>
			<!-- Form Name -->
			<legend><?php esc_html(_e( 'Custom Fields', 'pm-process-mover')); ?></legend>
			<table id="pm_ca_additional_fields" width="100%">
				<tbody>
				<tr>
					<td><input id="custom_fields" name="custom_fields" type="text" placeholder="Name of Custom Field" class="form-control"></td>
					<td>
	                    <button class="btn btn-danger btn-remove btn-remove-cf" type="button">
	                        <i class="glyphicon glyphicon-minus gs"></i>
	                    </button>
	                </td>
				</tr>
				</tbody>
			</table>
			<p><button id="pm_ca_additional_fields_add" class="btn btn-info btn-add" type="button"><i class="glyphicon glyphicon-plus gs"></i>Add</button></p>
			</fieldset>
			
			<hr />
			<?php submit_button( esc_html(__('Export', 'pm-content-auditor')), 'primary', 'pm_content_auditor_export', false, array('id' => 'pm_content_auditor_export') ); ?>
		</form>
		
		<section id="pm-content-auditor-export-form-process-wrapper" style="display: none;">
			<p class="processing-text"><?php esc_html(_e( 'Processing Files to Export. Please wait...', 'pm-process-mover')); ?> (<strong><span></span></strong>)</p>
			<div class="progress">
			    <div class="progress-bar" role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" style="width:0%">
			      <span class="sr-only"></span>
			    </div>
				<span class="progress-text"></span>
			</div>
			<p class="complete" style="display: none;"><?php esc_html(_e( 'Processing Complete. You can download it here.', 'pm-process-mover')); ?> <strong></strong><a href="#" target="_blank" ><?php esc_html(_e( 'Export CSV', 'pm-process-mover')); ?></a></<strong></p>
		</section>
	</div>	
	<?php
}

/*
	* Settings Page
*/


function pm_content_auditor_settings_page() {
	$setting_fields = pm_content_auditor_setting_fields();
	wp_enqueue_style( 'pm-font-awesome', 'https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.6.3/css/font-awesome.min.css', '', PM_CONTENT_AUDITOR_VERSION, 'all' );
	wp_enqueue_style( 'pm-bootstrap', 'https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css', '', PM_CONTENT_AUDITOR_VERSION, 'all' );	
	$options = get_option(PM_CONTENT_AUDITOR_SETTINGS_OPTION, array());
	?>	
	<div id="content_auditor_settings" class="wrap">
		<form method="post" class="form-horizontal pm_content_auditor_form" action="options.php"> 
			<?php settings_fields( 'pm-content-auditor-settings-group' ); ?>
			<?php do_settings_sections( 'pm-content-auditor-settings-group' ); ?>
			<?php 
			foreach($setting_fields as $skey =>  $fields): 
			?>
			<div>
				<h3><?php print $fields['name']; ?></h3>
				<p class="description"><?php print $fields['general_description']; ?></p>
				<div>
					<?php foreach($fields['fields'] as $fkey => $field): 
					$default_value = $setting_fields[$skey]['fields'][$field['name']]['default'];
					$option = (isset($options[$skey][$fkey]) ? $options[$skey][$fkey] : $default_value);
					$is_checkbox = ($field['type'] == 'checkbox' ? true : false);
					$checked = '';
					if( $is_checkbox && isset($options[$skey][$fkey])) {
						$checked = 'checked';
					}
					?>
					<?php if($is_checkbox): ?>
						<div class="form-group checkbox">
							<div class="col-sm-offset-1 col-sm-10">
							<div class="checkbox">
								<label for="<?php print pm_content_auditor_set_field('id',$skey,$field['name']); ?>"><input <?php print $checked; ?> type="<?php print pm_content_auditor_set_field('type',$skey,$field['name']); ?>" name="<?php print pm_content_auditor_set_field('name',$skey,$field['name']); ?>" id="<?php print pm_content_auditor_set_field('id',$skey,$field['name']); ?>" value="<?php print $option; ?>" class="form-control fb_hcs_setting_field" style="margin-top: 1px;" /> <?php print $field['label']; ?></label>
								<p class="description"><?php print pm_content_auditor_set_field('description',$skey,$field['name']); ?></p>
							</div>
							
							</div>
						</div>
					<?php else: ?>
						<div class="form-group">
							<label class="control-label col-sm-1" for="<?php print pm_content_auditor_set_field('id',$skey,$field['name']); ?>"><?php print $field['label']; ?></label>
							<div class="col-sm-10">
								<input <?php print $checked; ?> type="<?php print pm_content_auditor_set_field('type',$skey,$field['name']); ?>" name="<?php print pm_content_auditor_set_field('name',$skey,$field['name']); ?>" id="<?php print pm_content_auditor_set_field('id',$skey,$field['name']); ?>" maxlength="<?php print pm_content_auditor_set_field('limit',$skey,$field['name']); ?>" value="<?php print $option; ?>" class="form-control fb_hcs_setting_field" />
								<p class="description"><?php print pm_content_auditor_set_field('description',$skey,$field['name']); ?></p>
							</div>
						</div>
					<?php endif; ?>
					<?php endforeach; ?>
				</div>
			</div>
			<?php endforeach; ?>
			<?php submit_button( esc_html(__('Save Settings', 'pm-content-auditor')), 'secondary', 'pm_content_auditor_save', false, array('id' => 'pm_content_auditor_save') ); ?>
		</form>
	</div>	
	<?php
}


/*
	* Export Page
*/


function pm_content_auditor_logs_page() {
		
	wp_enqueue_style( 'pm-font-awesome', 'https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.6.3/css/font-awesome.min.css', '', PM_CONTENT_AUDITOR_VERSION, 'all' );
	wp_enqueue_style( 'pm-bootstrap', 'https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css', '', PM_CONTENT_AUDITOR_VERSION, 'all' );	
	wp_enqueue_style( 'pm-content-auditor-style', PM_CONTENT_AUDITOR_DIR.'modules/src/css/pm-content-auditor.css', '', PM_CONTENT_AUDITOR_VERSION, 'all' );
	wp_enqueue_script( 'pm-content-auditor-admin-script', PM_CONTENT_AUDITOR_DIR.'modules/src/js/pm-content-auditor.js', array('jquery'), PM_CONTENT_AUDITOR_VERSION, true );
	
	$logs = pm_content_auditor_log_objects();
	?>
	<?php if(!empty($logs)): ?>
	<div id="content_auditor_logs" class="wrap">
		<table class="table table-striped">
			<thead>
				<tr>
					<th><?php esc_html(_e('File', 'pm-content-auditor')); ?></th>
					<th><?php esc_html(_e('Total', 'pm-content-auditor')); ?></th>
					<th><?php esc_html(_e('Time', 'pm-content-auditor')); ?></th>
				</tr>
			</thead>
			
			
			<tbody>
				<?php foreach($logs as $log): 
					$filename = basename($log->filename);
				?>
				<tr>
					<td><a href="<?php print $log->filename; ?>" target="_blank"><?php print $filename; ?></a></td>
					<td><?php print $log->total; ?></td>
					<td><?php print $log->time; ?></td>
				</tr>
				<?php endforeach; ?>
			</tbody>
		</table>
		<?php endif; ?>
	</div>	
	<?php
}
