jQuery(document).ready(function($) {
	jQuery('#date_range_wrapper').hide();
	jQuery('#post_range_wrapper input.post_range').change(function() {
		var range_value = jQuery(this).val();
		if(range_value == 'date_range' ) {
			jQuery('#date_range_wrapper').slideDown();
		} else {
			jQuery('#date_range_wrapper').slideUp();
		}
	});
	
	var dateFormat = "mm/dd/yy",
      from = jQuery( "#start_date" )
        .datepicker({
          defaultDate: "+1w",
          changeMonth: true,
          numberOfMonths: 3
        })
        .on( "change", function() {
          to.datepicker( "option", "minDate", getDate( this ) );
        }),
      to = jQuery( "#end_date" ).datepicker({
        defaultDate: "+1w",
        changeMonth: true,
        numberOfMonths: 3
      })
      .on( "change", function() {
        from.datepicker( "option", "maxDate", getDate( this ) );
      });
 
    function getDate( element ) {
      var date;
      try {
        date = $.datepicker.parseDate( dateFormat, element.value );
      } catch( error ) {
        date = null;
      }
 
      return date;
    }
	
	
	/*
		* Process Form Submit
	*/
	jQuery('#pm_content_auditor_export').click(function(a) {
		a.preventDefault();
		var $form = jQuery('#pm-content-auditor-export-form');
		var $process_wrapper = jQuery('#pm-content-auditor-export-form-process-wrapper');
		pmCa.formData = $form.serializeObject();
		$form.slideUp(function() {
			$process_wrapper.show();
		});
		var data = {
			action: 'pm_content_auditor_ajax_process',
			formObject: pmCa.formData,
			paged: 1,
			time: pmCa.time
		};
		pm_content_auditor_ajax(data.paged, data);
		
	});
	
	function pm_content_auditor_ajax(paged, data) {
		jQuery.post(pmCa.ajaxurl, data, function(response) {
			var jsonData = JSON.parse(response);
			var current_page = parseInt(jsonData.paged) - 1;
			var progress_percentage = ( current_page / parseInt(jsonData.paged_total)) * 100;
			jQuery('#pm-content-auditor-export-form-process-wrapper p.processing-text span').text(jsonData.total_posts+ ' posts');
			jQuery('#pm-content-auditor-export-form-process-wrapper div.progress-bar').css('width', progress_percentage+'%');
			jQuery('#pm-content-auditor-export-form-process-wrapper span.progress-text').text(progress_percentage.toFixed(0)+'%');
			if( jsonData.last ) {
				jQuery('#pm-content-auditor-export-form-process-wrapper .complete a').attr('href', jsonData.fileDownload);
				jQuery('#pm-content-auditor-export-form-process-wrapper .complete').fadeIn();
			} else {
				var data = {
					action: 'pm_content_auditor_ajax_process',
					formObject: pmCa.formData,
					paged: jsonData.paged,
					time: pmCa.time
				};
				var jsonData = JSON.parse(response);
				pm_content_auditor_ajax(jsonData.paged, data);
			}
			
		});	
	}
	
});

//Disable the Remove Button
var rowCount = jQuery('table#pm_ca_additional_fields >tbody:last >tr').length;
if(rowCount == 1) {
	document.getElementsByClassName('btn-remove')[0].disabled = true;
}

jQuery(document).on('click', '#pm_ca_additional_fields_add', function(e) {
	e.preventDefault();
	
	var controlForm = jQuery('table#pm_ca_additional_fields');
	var currentEntry = jQuery('table#pm_ca_additional_fields>tbody>tr:last');
	var newEntry = jQuery(currentEntry.clone()).appendTo(controlForm);
	newEntry.find('input').val('');                                         //Remove the Data - as it is cloned from the above
	
	//Add the button  
	var rowCount = jQuery('table#pm_ca_additional_fields >tbody:last >tr').length;
	if(rowCount > 1) {
		var removeButtons = document.getElementsByClassName('btn-remove');
		for(var i = 0; i < removeButtons.length; i++) {
			removeButtons.item(i).disabled = false;
		}
	}
	 
}).on('click', '.btn-remove-cf', function(e) {
	jQuery(this).parents('tr:first').remove();
	
	//Disable the Remove Button
	var rowCount = jQuery('table#pm_ca_additional_fields >tbody:last >tr').length;
	if(rowCount == 1) {
		document.getElementsByClassName('btn-remove')[0].disabled = true;
	}

	e.preventDefault();
	return false;
});


(function( $ ) {
$.fn.serializeObject = function()
{
   var o = {};
   var a = this.serializeArray();
   $.each(a, function() {
       if (o[this.name]) {
           if (!o[this.name].push) {
               o[this.name] = [o[this.name]];
           }
           o[this.name].push(this.value || '');
       } else {
           o[this.name] = this.value || '';
       }
   });
   return o;
};

})( jQuery );